#pragma once

#include "ehs/EHS.h"
#include "ehs/Str.h"
#include "ehs/Serializer.h"

namespace ehs
{
	class RIFF_Chunk
	{
	private:
		Str_8 id;
		UInt_64 hashId;
		Serializer<> data;

	public:
		RIFF_Chunk();

		RIFF_Chunk(const Str_8& id, const Serializer<>& data);

		RIFF_Chunk(const RIFF_Chunk& chunk);

		RIFF_Chunk& operator=(const RIFF_Chunk& chunk);

		Str_8 GetId() const;

		UInt_64 GetHashId() const;

		Serializer<> GetData() const;

		bool IsValid() const;
	};
}